import * as THREE from 'three';
export type PointsRepresentation = Float32Array | THREE.Vector3[] | THREE.Vector2[] | THREE.Vector3Tuple[] | THREE.Vector2Tuple[] | number[];
export type WidthCallback = (p: number) => any;
export declare class MeshLineGeometry extends THREE.BufferGeometry {
    type: string;
    isMeshLine: boolean;
    positions: number[];
    previous: number[];
    next: number[];
    side: number[];
    width: number[];
    indices_array: number[];
    uvs: number[];
    counters: number[];
    widthCallback: WidthCallback | null;
    matrixWorld: THREE.Matrix4;
    geometry: THREE.BufferGeometry;
    points: PointsRepresentation;
    constructor();
    setMatrixWorld(matrixWorld: THREE.Matrix4): void;
    setGeometry(g: THREE.BufferGeometry, c: (p: number) => any): void;
    setPoints(points: PointsRepresentation, wcb?: WidthCallback): void;
    compareV3(a: number, b: number): boolean;
    copyV3(a: number): THREE.Vector3Tuple;
    process(): void;
    /**
     * Fast method to advance the line by one position.  The oldest position is removed.
     * @param position
     */
    advance({ x, y, z }: THREE.Vector3): void;
}
